# Python client for Binance API

[![PyPI - Version](https://img.shields.io/pypi/v/openxapi-binance)](https://pypi.org/project/openxapi-binance/)

This package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

Please do not edit the generated code manually, but rather regenerate it from [OpenXAPI](https://github.com/openxapi/openxapi).

## Supported APIs

| Product | Module | Sub Products |
|:---------:|-----------|--------|
| [Spot API](binance/spot_README.md) | `binance.spot` | ✅ [Spot Trading](https://developers.binance.com/docs/binance-spot-api-docs/rest-api/general-api-information) <br> ✅ [Margin Trading](https://developers.binance.com/docs/margin_trading/Introduction) <br> ✅ [Algo Trading](https://developers.binance.com/docs/algo/Introduction) <br> ✅ [Wallet](https://developers.binance.com/docs/wallet/Introduction) <br> ✅ [Copy Trading](https://developers.binance.com/docs/copy_trading/Introduction) <br> ✅ [Convert](https://developers.binance.com/docs/convert/Introduction) <br> ✅ [Sub Account](https://developers.binance.com/docs/sub_account/Introduction) <br>✅ [Binance Link](https://developers.binance.com/docs/binance_link/change-log) <br>✅ [Futures Data](https://developers.binance.com/docs/derivatives/futures-data/general-info) <br> ✅ [Portfolio Margin Pro](https://developers.binance.com/docs/derivatives/portfolio-margin-pro/general-info) <br>✅ [Staking](https://developers.binance.com/docs/staking/Introduction) <br>✅ [Dual Investment](https://developers.binance.com/docs/dual_investment/Introduction) <br>✅ [Mining](https://developers.binance.com/docs/mining/Introduction) <br>✅ [Crypto Loan](https://developers.binance.com/docs/crypto_loan/Introduction) <br>✅ [VIP Loan](https://developers.binance.com/docs/vip_loan/Introduction) <br>✅ [C2C](https://developers.binance.com/docs/c2c/Introduction) <br>✅ [Fiat](https://developers.binance.com/docs/fiat/Introduction) <br>✅ [NFT](https://developers.binance.com/docs/nft/Introduction) <br>✅ [Gift Card](https://developers.binance.com/docs/gift_card/Introduction) <br>✅ [Rebate](https://developers.binance.com/docs/rebate/Introduction) <br>✅ [Simple Earn](https://developers.binance.com/docs/simple_earn/Introduction) <br>✅ [Binance Pay History](https://developers.binance.com/docs/pay/Introduction) |
| [USD-M Futures API](binance/umfutures_README.md) | `binance.umfutures` | ✅ [USDS Margined Futures](https://developers.binance.com/docs/derivatives/usds-margined-futures/general-info) <br> ✅ [Binance Link](https://developers.binance.com/docs/binance_link/link-and-trade/futures) |
| [COIN-M Futures API](binance/cmfutures_README.md) | `binance.cmfutures` | ✅ [COIN Margined Futures](https://developers.binance.com/docs/derivatives/coin-margined-futures/general-info) |
| [Options API](binance/options_README.md) | `binance.options` | ✅ [Options](https://developers.binance.com/docs/derivatives/option/general-info) |
| [Portfolio Margin API](binance/pmargin_README.md) | `binance.pmargin` | ✅ [Portfolio Margin](https://developers.binance.com/docs/derivatives/portfolio-margin/general-info) |

## Requirements.

Python 3.8+

## Installation & Usage

```bash
pip install openxapi-binance
```

## Getting Started

In your own code, to use this library to connect and interact with spot,
you can run the following:

```python
import os
import time
from pprint import pprint

from binance import spot
from binance.spot.rest import ApiException
from binance.spot.auth import BinanceAuth

# Defining the host is optional and defaults to https://api.binance.com
# See configuration.py for a list of all supported configuration parameters.
configuration = spot.Configuration(
    host = "https://api.binance.com"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

conf = spot.Configuration(
    auth=BinanceAuth(
        api_key=os.getenv("BINANCE_API_KEY"),
        # secret_key=os.getenv("BINANCE_SECRET_KEY"), # if you want to use HMAC auth
        private_key_path="/path/to/private_key.pem", # Automatically detects RSA/Ed25519 private keys
    ),
)

# Enter a context with an instance of the API client
with spot.ApiClient(conf) as api_client:
    # Create an instance of the API class
    api_instance = spot.SpotTradingApi(api_client)
    try:
        # Query Commission Rates (USER_DATA)
        api_response = api_instance.get_account_v3(
            timestamp=int(time.time() * 1000)
        )
        print("The response of AccountApi->get_account_v3:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AccountApi->get_account_v3: %s\n" % e)
```
