# coding: utf-8

"""
    Binance Spot API

    OpenAPI specification for Binance exchange - Spot API

    The version of the OpenAPI document: 0.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from binance.spot.models.get_eth_staking_account_v2_resp_holdings import GetEthStakingAccountV2RespHoldings
from binance.spot.models.get_eth_staking_account_v2_resp_profit import GetEthStakingAccountV2RespProfit
from typing import Optional, Set
from typing_extensions import Self

class GetEthStakingAccountV2Resp(BaseModel):
    """
    GetEthStakingAccountV2Resp
    """ # noqa: E501
    holding_in_eth: Optional[StrictStr] = Field(default=None, alias="holdingInETH")
    holdings: Optional[GetEthStakingAccountV2RespHoldings] = None
    profit: Optional[GetEthStakingAccountV2RespProfit] = None
    thirty_days_profit_in_eth: Optional[StrictStr] = Field(default=None, alias="thirtyDaysProfitInETH")
    __properties: ClassVar[List[str]] = ["holdingInETH", "holdings", "profit", "thirtyDaysProfitInETH"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetEthStakingAccountV2Resp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of holdings
        if self.holdings:
            _dict['holdings'] = self.holdings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of profit
        if self.profit:
            _dict['profit'] = self.profit.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetEthStakingAccountV2Resp from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "holdingInETH": obj.get("holdingInETH"),
            "holdings": GetEthStakingAccountV2RespHoldings.from_dict(obj["holdings"]) if obj.get("holdings") is not None else None,
            "profit": GetEthStakingAccountV2RespProfit.from_dict(obj["profit"]) if obj.get("profit") is not None else None,
            "thirtyDaysProfitInETH": obj.get("thirtyDaysProfitInETH")
        })
        return _obj


